
class BaseModel:
    def predict(self, input):
        raise NotImplementedError


class ModelA(BaseModel):
    def predict(self, input):
        # Perform prediction using Model A's algorithm
        return input * 2


class ModelB(BaseModel):
    def predict(self, input):
        # Perform prediction using Model B's algorithm
        return input + 5


class Ensemble:
    def __init__(self):
        self.models = []

    def add_model(self, model):
        self.models.append(model)

    def remove_model(self, model):
        # Remove model from the ensemble
        # ...
        print("remove_model")

    def predict(self, input):
        predictions = [model.predict(input) for model in self.models]
        return sum(predictions) / len(predictions)  # Return average prediction


if __name__ == '__main__':
    # Create ensemble
    ensemble = Ensemble()

    # Create and add models to the ensemble
    modelA = ModelA()
    modelB = ModelB()
    ensemble.add_model(modelA)
    ensemble.add_model(modelB)

    # Make predictions using the ensemble
    input_value = 10
    prediction = ensemble.predict(input_value)
    print("Ensemble prediction:", prediction)
